Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -2059,72 +2289,72 @@
        DO  k = nzb+1, nzb_max_l
 
-          ibit11 = REAL( IBITS(advc_flags_1(k,j,i),11,1), KIND = wp )
-          ibit10 = REAL( IBITS(advc_flags_1(k,j,i),10,1), KIND = wp )
-          ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
+          ibit2 = REAL( IBITS(advc_flags_m(k,j,i),2,1), KIND = wp )
+          ibit1 = REAL( IBITS(advc_flags_m(k,j,i),1,1), KIND = wp )
+          ibit0 = REAL( IBITS(advc_flags_m(k,j,i),0,1), KIND = wp )
 
           u_comp(k) = u(k,j,i+1) + u(k,j,i)
-          flux_r(k) = ( u_comp(k) - gu ) * (                                  &
-                     ( 37.0_wp * ibit11 * adv_mom_5                           &
-                  +     7.0_wp * ibit10 * adv_mom_3                           &
-                  +              ibit9  * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( u(k,j,i+1) + u(k,j,i)   )               &
-              -      (  8.0_wp * ibit11 * adv_mom_5                           &
-                  +              ibit10 * adv_mom_3                           & 
-                     ) *                                                      &
-                                    ( u(k,j,i+2) + u(k,j,i-1) )               &
-              +      (           ibit11 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( u(k,j,i+3) + u(k,j,i-2) )               &
-                                           )
-
-          diss_r(k) = - ABS( u_comp(k) - gu ) * (                             &
-                     ( 10.0_wp * ibit11 * adv_mom_5                           &
-                  +     3.0_wp * ibit10 * adv_mom_3                           &
-                  +              ibit9  * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( u(k,j,i+1) - u(k,j,i)   )               &
-              -      (  5.0_wp * ibit11 * adv_mom_5                           &
-                  +              ibit10 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( u(k,j,i+2) - u(k,j,i-1) )               &
-              +      (           ibit11 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( u(k,j,i+3) - u(k,j,i-2) )               &
+          flux_r(k) = ( u_comp(k) - gu ) * (                                   &
+                     ( 37.0_wp * ibit2 * adv_mom_5                             &
+                  +     7.0_wp * ibit1 * adv_mom_3                             &
+                  +              ibit0 * adv_mom_1                             &
+                     ) *                                                       &
+                                    ( u(k,j,i+1) + u(k,j,i)   )                &
+              -      (  8.0_wp * ibit2 * adv_mom_5                             &
+                  +              ibit1 * adv_mom_3                             & 
+                     ) *                                                       &
+                                    ( u(k,j,i+2) + u(k,j,i-1) )                &
+              +      (           ibit2 * adv_mom_5                             &
+                     ) *                                                       &
+                                    ( u(k,j,i+3) + u(k,j,i-2) )                &
+                                           )                                  
+                                                                              
+          diss_r(k) = - ABS( u_comp(k) - gu ) * (                              &
+                     ( 10.0_wp * ibit2 * adv_mom_5                             &
+                  +     3.0_wp * ibit1 * adv_mom_3                             &
+                  +              ibit0 * adv_mom_1                             &
+                     ) *                                                       &
+                                    ( u(k,j,i+1) - u(k,j,i)   )                &
+              -      (  5.0_wp * ibit2 * adv_mom_5                             &
+                  +              ibit1 * adv_mom_3                             &
+                     ) *                                                       &
+                                    ( u(k,j,i+2) - u(k,j,i-1) )                &
+              +      (           ibit2 * adv_mom_5                             &
+                     ) *                                                       &
+                                    ( u(k,j,i+3) - u(k,j,i-2) )                &
                                                 )
 
-          ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
-          ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
-          ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
+          ibit5 = REAL( IBITS(advc_flags_m(k,j,i),5,1), KIND = wp )
+          ibit4 = REAL( IBITS(advc_flags_m(k,j,i),4,1), KIND = wp )
+          ibit3 = REAL( IBITS(advc_flags_m(k,j,i),3,1), KIND = wp )
 
           v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                     ( 37.0_wp * ibit14 * adv_mom_5                           &
-                  +     7.0_wp * ibit13 * adv_mom_3                           &
-                  +              ibit12 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( u(k,j+1,i) + u(k,j,i)   )               &
-              -      (  8.0_wp * ibit14 * adv_mom_5                           &
-                  +              ibit13 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( u(k,j+2,i) + u(k,j-1,i) )               &
-              +      (           ibit14 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( u(k,j+3,i) + u(k,j-2,i) )               &
-                                  )
-
-          diss_n(k) = - ABS ( v_comp(k) ) * (                                 &
-                     ( 10.0_wp * ibit14 * adv_mom_5                           &
-                  +     3.0_wp * ibit13 * adv_mom_3                           &
-                  +              ibit12 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( u(k,j+1,i) - u(k,j,i)   )               &
-              -      (  5.0_wp * ibit14 * adv_mom_5                           &
-                  +              ibit13 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( u(k,j+2,i) - u(k,j-1,i) )               &
-              +      (           ibit14 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( u(k,j+3,i) - u(k,j-2,i) )               &
+          flux_n(k) = v_comp(k) * (                                            &
+                     ( 37.0_wp * ibit5 * adv_mom_5                             &
+                  +     7.0_wp * ibit4 * adv_mom_3                             &
+                  +              ibit3 * adv_mom_1                             &
+                     ) *                                                       &
+                                    ( u(k,j+1,i) + u(k,j,i)   )                &
+              -      (  8.0_wp * ibit5 * adv_mom_5                             &
+                  +              ibit4 * adv_mom_3                             &
+                     ) *                                                       &
+                                    ( u(k,j+2,i) + u(k,j-1,i) )                &
+              +      (           ibit5 * adv_mom_5                             &
+                     ) *                                                       &
+                                    ( u(k,j+3,i) + u(k,j-2,i) )                &
+                                  )                                           
+                                                                              
+          diss_n(k) = - ABS ( v_comp(k) ) * (                                  &
+                     ( 10.0_wp * ibit5 * adv_mom_5                             &
+                  +     3.0_wp * ibit4 * adv_mom_3                             &
+                  +              ibit3 * adv_mom_1                             &
+                     ) *                                                       &
+                                    ( u(k,j+1,i) - u(k,j,i)   )                &
+              -      (  5.0_wp * ibit5 * adv_mom_5                             &
+                  +              ibit4 * adv_mom_3                             &
+                     ) *                                                       &
+                                    ( u(k,j+2,i) - u(k,j-1,i) )                &
+              +      (           ibit5 * adv_mom_5                             &
+                     ) *                                                       &
+                                    ( u(k,j+3,i) - u(k,j-2,i) )                &
                                             )
        ENDDO
@@ -2133,21 +2363,21 @@
 
           u_comp(k) = u(k,j,i+1) + u(k,j,i)
-          flux_r(k) = ( u_comp(k) - gu ) * (                                  &
-                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                &
-                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                &
-                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-          diss_r(k) = - ABS( u_comp(k) - gu ) * (                             &
-                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                &
-                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                &
-                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
-
-          v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                &
-                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                &
-                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                &
-                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                &
+          flux_r(k) = ( u_comp(k) - gu ) * (                                   &
+                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                 &
+                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                 &
+                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5   
+          diss_r(k) = - ABS( u_comp(k) - gu ) * (                              &
+                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                 &
+                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                 &
+                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5   
+                                                                               
+          v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv                           
+          flux_n(k) = v_comp(k) * (                                            &
+                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                 &
+                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                 &
+                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5   
+          diss_n(k) = - ABS( v_comp(k) ) * (                                   &
+                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                 &
+                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                 &
                        +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
 
@@ -2161,5 +2391,5 @@
 !--    calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    advc_flags_1.
+!--    advc_flags_m.
        flux_t(nzb) = 0.0_wp
        diss_t(nzb) = 0.0_wp
@@ -2169,41 +2399,41 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit17
-          k_pp  = k + 2 * ( 1 - ibit15 )
-          k_mm  = k - 2 * ibit17
+          ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit8
+          k_pp  = k + 2 * ( 1 - ibit6 )
+          k_mm  = k - 2 * ibit8
 
           w_comp(k) = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit17 * adv_mom_5                           &
-                  +     7.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)  + u(k,j,i)     )                &
-              -      (  8.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
-                                                  )
-
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit17 * adv_mom_5                           &
-                  +     3.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)   - u(k,j,i)    )                &
-              -      (  5.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                            &
+                     ( 37.0_wp * ibit8 * adv_mom_5                             &
+                  +     7.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)   + u(k,j,i)    )                 &
+              -      (  8.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k_pp,j,i)  + u(k-1,j,i)  )                 &
+              +      (           ibit8 * adv_mom_5                             &
+                     ) *                                                       &
+                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                 &
+                                                  )                            
+                                                                               
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                   &
+                     ( 10.0_wp * ibit8 * adv_mom_5                             &
+                  +     3.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                 &
+              -      (  5.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                 &
+              +      (           ibit8 * adv_mom_5                             &
+                     ) *                                                       &
+                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                 &
                                                            )
        ENDDO
@@ -2211,37 +2441,37 @@
        DO  k = nzb+3, nzt-2
 
-          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
 
           w_comp(k) = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit17 * adv_mom_5                           &
-                  +     7.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)  + u(k,j,i)     )                &
-              -      (  8.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k+2,j,i) + u(k-1,j,i)   )                 &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k+3,j,i) + u(k-2,j,i) )                   &
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                            &
+                     ( 37.0_wp * ibit8 * adv_mom_5                             &
+                  +     7.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)  + u(k,j,i)     )                 &
+              -      (  8.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k+2,j,i) + u(k-1,j,i)   )                  &
+              +      (           ibit8 * adv_mom_5                             & 
+                     ) *                                                       &
+                                ( u(k+3,j,i) + u(k-2,j,i) )                    &
                                                   )
 
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit17 * adv_mom_5                           &
-                  +     3.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)   - u(k,j,i)    )                &
-              -      (  5.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k+2,j,i)  - u(k-1,j,i)  )                 &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k+3,j,i) - u(k-2,j,i) )                   &
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                   &
+                     ( 10.0_wp * ibit8 * adv_mom_5                             &
+                  +     3.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)  - u(k,j,i)    )                  &
+              -      (  5.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k+2,j,i)  - u(k-1,j,i)  )                  &
+              +      (           ibit8 * adv_mom_5                             &
+                     ) *                                                       &
+                                ( u(k+3,j,i) - u(k-2,j,i)   )                  &
                                                            )
        ENDDO
@@ -2251,41 +2481,41 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit17
-          k_pp  = k + 2 * ( 1 - ibit15 )
-          k_mm  = k - 2 * ibit17
+          ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit8
+          k_pp  = k + 2 * ( 1 - ibit6 )
+          k_mm  = k - 2 * ibit8
 
           w_comp(k) = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit17 * adv_mom_5                           &
-                  +     7.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)  + u(k,j,i)     )                &
-              -      (  8.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                            &
+                     ( 37.0_wp * ibit8 * adv_mom_5                             &
+                  +     7.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)   + u(k,j,i)    )                 &
+              -      (  8.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k_pp,j,i)  + u(k-1,j,i)  )                 &
+              +      (           ibit8 * adv_mom_5                             &
+                     ) *                                                       &
+                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                 &
                                                   )
 
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit17 * adv_mom_5                           &
-                  +     3.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)   - u(k,j,i)    )                &
-              -      (  5.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                   &
+                     ( 10.0_wp * ibit8 * adv_mom_5                             &
+                  +     3.0_wp * ibit7 * adv_mom_3                             &
+                  +              ibit6 * adv_mom_1                             &
+                     ) *                                                       &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                 &
+              -      (  5.0_wp * ibit8 * adv_mom_5                             &
+                  +              ibit7 * adv_mom_3                             &
+                     ) *                                                       &
+                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                 &
+              +      (           ibit8 * adv_mom_5                             &
+                     ) *                                                       &
+                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                 &
                                                            )
        ENDDO
